// Author: Pete Kirkham
//
// quad store matching query bench.
//
#include <xmmintrin.h>
#include <iostream>

#include "utils/string_utils.h"

int main (int narg, char** argvp)
{
#ifdef GENERATE
    // generate code to output shuffles
    for (size_t i(0); i <= 0xff; ++i)
    {
        std::cout << "std::cout << \"shuffle(a, 0x" << to_hex(i) << ") => \" << to_i4(_mm_shuffle_epi32(a, 0x" << to_hex(i) << ")) << std::endl;" << std::endl;
    }
#else
    // output shuffles
    __m128i a(_mm_set_epi32(0, 1, 2, 3));
    std::cout << "a =              " << to_i4(a) << std::endl;

#include "shuffle_epi32.inl"
#endif
}
